# coding: utf-8

"""
    Endpoint Test Results API

    Retrieve results for scheduled and dynamic tests on endpoint agents.

    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from thousandeyes_sdk.endpoint_test_results.models.endpoint_path_vis_hop import EndpointPathVisHop
from thousandeyes_sdk.endpoint_test_results.models.endpoint_test_result_protocol import EndpointTestResultProtocol
from thousandeyes_sdk.endpoint_test_results.models.tcp_path_trace_mode_response import TcpPathTraceModeResponse
from thousandeyes_sdk.endpoint_test_results.models.udp_path_trace_mode_response import UdpPathTraceModeResponse
from typing import Optional, Set
from typing_extensions import Self

class EndpointPathVisRoute(BaseModel):
    """
    EndpointPathVisRoute
    """ # noqa: E501
    path_id: Optional[StrictStr] = Field(default=None, description="Unique ID of path trace.", alias="pathId")
    protocol: Optional[EndpointTestResultProtocol] = None
    tcp_path_trace_mode: Optional[TcpPathTraceModeResponse] = Field(default=None, alias="tcpPathTraceMode")
    udp_path_trace_mode: Optional[UdpPathTraceModeResponse] = Field(default=None, alias="udpPathTraceMode")
    hops: Optional[List[EndpointPathVisHop]] = Field(default=None, description="Array of hop objects indicating each step in the traceroute.")
    __properties: ClassVar[List[str]] = ["pathId", "protocol", "tcpPathTraceMode", "udpPathTraceMode", "hops"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
        extra="allow",
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return self.model_dump_json(by_alias=True, exclude_unset=True, exclude_none=True)

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EndpointPathVisRoute from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "path_id",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in hops (list)
        _items = []
        if self.hops:
            for _item in self.hops:
                if _item:
                    _items.append(_item.to_dict())
            _dict['hops'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EndpointPathVisRoute from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "pathId": obj.get("pathId"),
            "protocol": obj.get("protocol"),
            "tcpPathTraceMode": obj.get("tcpPathTraceMode"),
            "udpPathTraceMode": obj.get("udpPathTraceMode"),
            "hops": [EndpointPathVisHop.from_dict(_item) for _item in obj["hops"]] if obj.get("hops") is not None else None
        })
        return _obj


